//=========================================================================
//		NSDictionary+DataTransform.m
//=========================================================================
//  Created by Sarwat Khan on Wed Jun 11 2003.
//  Copyright (c) 2003, Sarwat Khan. All rights reserved.
//  
//  Redistribution and use in source and binary forms, with or without
//  modification, are permitted provided that the following conditions are
//  met:
//          
//      1. Redistributions of source code must retain the above copyright
//         notice, this list of conditions and the following disclaimer.
//          
//      2. Redistributions in binary form must reproduce the above
//         copyright notice, this list of conditions and the following disclaimer
//         in the documentation and/or other materials provided with the
//         distribution.
//          
//      3. Neither Sarwat Khans name nor the names of any contributors to
//         the Tomato Torrent Software may be used to endorse or promote
//         products derived from this software without specific prior written
//         permission.
//  
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
//  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
//  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
//  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
//  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
//  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
//  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
//  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
//  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
//  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
//  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


#import "NSDictionary+DataTransform.h"

@implementation NSDictionary (DataTransform)
- dictionaryMappingObjectsUsingFunction:(id (*)(id, id, void *))map context:(void *)context;
{
	id		ite = [self keyEnumerator];
	id		key, temp, result;
	
	temp = [[NSMutableDictionary allocWithZone:[self zone]] initWithCapacity:[self count]];
	
	while (key = [ite nextObject])
	{
		[temp setObject:map([self objectForKey:key], key, context)
				 forKey:key];
	}
	
	result = [temp copyWithZone:[self zone]];	//immutable result
	[temp release];
	
	return [result autorelease];
}
							//new_object = map(object, key, context);
@end


@implementation NSMutableDictionary (DataTransform)
- mapObjectsUsingFunction:(id (*)(id, id, void *))map context:(void *)context;
{
	id		ite = [self keyEnumerator];
	id		key;
	
	while (key = [ite nextObject])
	{
		[self setObject:map([self objectForKey:key], key, context)
				 forKey:key];
	}
	
	return self;
}
@end

@implementation NSArray (DataTransform)
- arrayByMappingObjectsUsingFunction:(id (*)(id, void*))map context:(void*)context
{
	id		ite = [self objectEnumerator];
	id		object, temp, result;
	
	temp = [[NSMutableArray allocWithZone:[self zone]] initWithCapacity:[self count]];
	
	while (object = [ite nextObject])
		[temp addObject:map(object, context)];
		
	result = [temp copyWithZone:[self zone]];	//immutable result
	[temp release];
	
	return [result autorelease];
}

- arrayByFilteringObjectsUsingFunction:(id (*)(id, void*))filter context:(void*)context
{
	id		ite = [self objectEnumerator];
	id		object, temp, foo, result;
	
	temp = [[NSMutableArray allocWithZone:[self zone]] initWithCapacity:[self count]];
	
	while (object = [ite nextObject])
	{
		if (foo = filter(object, context))
			[temp addObject:foo];
	}
	
	result = [temp copyWithZone:[self zone]];	//immutable result
	[temp release];
	
	return [result autorelease];
}

	
@end
