//=========================================================================
//		NSFileManager+ResourceDirectories.m					Tomato
//=========================================================================
//  Created by Sarwat Khan on 26/04/05.
//  Copyright (c) 2005 Sarwat Khan. All rights reserved.

#import "NSFileManager+ResourceDirectories.h"


@implementation NSFileManager (ResourceDirectories)
- (NSString*) cachesDirectoryNamed:(NSString*)name inDomain:(NSSearchPathDomainMask)domain;
{
	id		userLibrary;
	id		cacheFolder;
	id		processCacheFolder;
	id		result = NSTemporaryDirectory();
	BOOL	foo = false;
	
	userLibrary = [NSSearchPathForDirectoriesInDomains(NSLibraryDirectory, domain, YES) lastObject];
	cacheFolder = [userLibrary stringByAppendingPathComponent:@"Caches"];
	processCacheFolder = [cacheFolder stringByAppendingPathComponent:name];
	
	[self createDirectoryAtPath:userLibrary attributes:nil];
	[self createDirectoryAtPath:cacheFolder attributes:nil];
	[self createDirectoryAtPath:processCacheFolder attributes:nil];
	
	if ([self fileExistsAtPath:processCacheFolder isDirectory:&foo] && foo)
		result = processCacheFolder;
	
	return result;
}

- (NSString*) logsDirectoryNamed:(NSString*)name inDomain:(NSSearchPathDomainMask)domain;
{
	id		userLibrary;
	id		logsFolder;
	id		processLogsFolder;
	id		result = NSTemporaryDirectory();
	BOOL	foo = false;
	
	userLibrary = [NSSearchPathForDirectoriesInDomains(NSLibraryDirectory, domain, YES) lastObject];
	logsFolder = [userLibrary stringByAppendingPathComponent:@"Logs"];
	processLogsFolder = [logsFolder stringByAppendingPathComponent:name];
	
	[self createDirectoryAtPath:userLibrary attributes:nil];
	[self createDirectoryAtPath:logsFolder attributes:nil];
	[self createDirectoryAtPath:processLogsFolder attributes:nil];
	
	if ([self fileExistsAtPath:processLogsFolder isDirectory:&foo] && foo)
		result = processLogsFolder;
	
	return result;
}

@end
