//  Copyright (c) 2003, Sarwat Khan. All rights reserved.
//  
//  Redistribution and use in source and binary forms, with or without
//  modification, are permitted provided that the following conditions are
//  met:
//          
//      1. Redistributions of source code must retain the above copyright
//         notice, this list of conditions and the following disclaimer.
//          
//      2. Redistributions in binary form must reproduce the above
//         copyright notice, this list of conditions and the following disclaimer
//         in the documentation and/or other materials provided with the
//         distribution.
//          
//      3. Neither Sarwat Khans name nor the names of any contributors to
//         the Tomato Torrent Software may be used to endorse or promote
//         products derived from this software without specific prior written
//         permission.
//  
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
//  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
//  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
//  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
//  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
//  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
//  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
//  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
//  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
//  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
//  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

/* DownloadSetupWindowController */

#import <Cocoa/Cocoa.h>

@interface DownloadSetupWindowController : NSWindowController
{
	id	__agent;
	
    IBOutlet id __autostartTitle;
    IBOutlet id __commentBox;
    IBOutlet id __commentText;
    IBOutlet id __commentView;
	IBOutlet id __detailsBox;
    IBOutlet id __detailsFetchProgress;
	IBOutlet id __detailsOutline;
    IBOutlet id __detailsToggleButton;
    IBOutlet id __downloadOptionsBox;
    IBOutlet id __downloadOptionsToggleButton;
    IBOutlet id __downloadOptionsView;
    IBOutlet id __fileNameTabView;
    IBOutlet id __fileNameText;
    IBOutlet id __moduleOptionsController;
    IBOutlet id __saveToBox;
    IBOutlet id __saveToMenu;
    IBOutlet id __startButton;
    IBOutlet id __torrentDetailsView;
	
	id			__autoStartTimer;
	
	BOOL		__saveOptions;
	BOOL		__gotGo;
	
	id			__emptyOptionsView;
	id			__emptyDetailsView;
	NSRect		__saveMenuSuperFrame;
	NSRect		__saveMenuFrame;
	
	id			__tomatoMetainfo;
	
	id			__outlineRoot;
	id			__pairs;
	id			__containerFormatter;
}
- (IBAction)choseSaveTarget:(id)sender;
- (IBAction)saveOptions:(id)sender;
- (IBAction)startDownload:(id)sender;
- (IBAction)toggleDetailsDisplay:(id)sender;
- (IBAction)toggleOptionsDisplay:(id)sender;

- closeWithoutClosingDocument;
- showTorrentDownloadSetup;
- setTomatoMetainfoDictionary:foo;
@end
