/* TrackerDocumentController */
//  Copyright (c) 2003, Sarwat Khan. All rights reserved.
//  
//  Redistribution and use in source and binary forms, with or without
//  modification, are permitted provided that the following conditions are
//  met:
//          
//      1. Redistributions of source code must retain the above copyright
//         notice, this list of conditions and the following disclaimer.
//          
//      2. Redistributions in binary form must reproduce the above
//         copyright notice, this list of conditions and the following disclaimer
//         in the documentation and/or other materials provided with the
//         distribution.
//          
//      3. Neither Sarwat Khans name nor the names of any contributors to
//         the Tomato Torrent Software may be used to endorse or promote
//         products derived from this software without specific prior written
//         permission.
//  
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
//  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
//  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
//  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
//  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
//  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
//  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
//  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
//  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
//  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
//  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

#import <Cocoa/Cocoa.h>

@interface TrackerDocumentController : NSObject
{
    IBOutlet id _advancedOptionsBox;
    IBOutlet id _advancedOptionsView;
    IBOutlet id _allowedDirButtton;
    IBOutlet id _allowedDirText;
    IBOutlet id _listenPortText;
    IBOutlet id _loggingToText;
    IBOutlet id _trackerOutput;
    IBOutlet id _trackerStartDateText;
	IBOutlet id _trackerURLText;
    IBOutlet id _windowController;
	IBOutlet id	_startSaveButton;
	IBOutlet id	_stopButton;
	
	id		_editView;
	NSSize	_initialEditViewSize;
	NSSize	_expandedEditViewSize;
	
	id		_runView;
	NSSize	_initialRunViewSize;
	
	id		_saveEmptyView;
	
	id		_tableController;
	NSRect	_savedContentFrame;
	
	BOOL	_editingDisabled;
	
	NSTask*	_task;
	id		_fileHandle;
	
	id		_hostID;
	
	id		__fontAttribs;
}

+ makeTrackerDocumentWindowController;
- windowController;
- window;
- document;
- documentIsSpecified:(BOOL)is;

- (void) reloadData;
- showTrackerProgress:logFilePath;
- stopShowingTrackerProgress;

- setupWindowForDocumentState;

- (IBAction)chooseAllowedDir:(id)sender;
- (IBAction)listenPortEdited:(id)sender;
- (IBAction)restoreOptionsDefaults:(id)sender;
- (IBAction)saveTrackerAs:(id)sender;
- (IBAction)setAllowedDirOn:(id)sender;
- (IBAction)startOrSaveTracker:(id)sender;
- (IBAction)stopRunningTracker:(id)sender;
- (IBAction)toggleAdvancedOptions:(id)sender;
@end
