//==============================================================================
//		tomato_agent.h											TomatoTorrent
//==============================================================================
//  Created by Sarwat Khan on Wed Jun 04 2003.
//  Copyright (c) 2003, Sarwat Khan. All rights reserved.
//  
//  Redistribution and use in source and binary forms, with or without
//  modification, are permitted provided that the following conditions are
//  met:
//          
//      1. Redistributions of source code must retain the above copyright
//         notice, this list of conditions and the following disclaimer.
//          
//      2. Redistributions in binary form must reproduce the above
//         copyright notice, this list of conditions and the following disclaimer
//         in the documentation and/or other materials provided with the
//         distribution.
//          
//      3. Neither Sarwat Khan’s name nor the names of any contributors to
//         the Tomato Torrent Software may be used to endorse or promote
//         products derived from this software without specific prior written
//         permission.
//  
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
//  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
//  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
//  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
//  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
//  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
//  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
//  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
//  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
//  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
//  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


#ifndef __bittorrentagent__
#define __bittorrentagent__

#import <stdbool.h>
#include <sys/types.h>
#ifndef k_ttagent_python_path
#define k_ttagent_python_path				"/usr/bin/python"
#endif

#define k_ttagent_python_sourcedir_generic	"pythonZip"
#define k_ttagent_python_zipmodule			"ttagent.zip"

//	ttagent_context. 
//
//		not private. last_error_desc is malloced, free'd by shutdown.
struct ttagent_context
{
	pid_t		pid;
	int			read_fd;
	int			write_fd;
	int			error_fd;
	char*		last_error_desc;
	
	void		*_extra;
};
typedef struct ttagent_context	ttagent_context;

//	globals
//
//	default state requires python2.3 or better (zipimport).
extern char g_ttagent_python_sourcedir[];
extern bool g_ttagent_python_zipimport;

void				ttagent_initialize(const char* pythonPathInfoUTF8);

ttagent_context*	ttagent_startup(const char *resource_dir, char** out_error_desc);
void				ttagent_shutdown(ttagent_context *);

// note: strings are UTF-8 encoded.

bool		ttagent_send_message(ttagent_context *agent, const char *commandUTF8);
char*		ttagent_read_answer(ttagent_context *agent, char** answerUTF8);

bool 		ttagent_send_message_fd(int output, const char *commandUTF8, char **error_desc);
char*		ttagent_read_answer_fd(int input, char** answerUTF8, char** error_desc);


#endif
