//==============================================================================
//		TomatoTorrentAgent.h									TomatoTorrent
//==============================================================================
//  Created by Sarwat Khan on Tue Jun 03 2003.
//  Copyright (c) 2003, Sarwat Khan. All rights reserved.
//  
//  Redistribution and use in source and binary forms, with or without
//  modification, are permitted provided that the following conditions are
//  met:
//          
//      1. Redistributions of source code must retain the above copyright
//         notice, this list of conditions and the following disclaimer.
//          
//      2. Redistributions in binary form must reproduce the above
//         copyright notice, this list of conditions and the following disclaimer
//         in the documentation and/or other materials provided with the
//         distribution.
//          
//      3. Neither Sarwat Khan’s name nor the names of any contributors to
//         the Tomato Torrent Software may be used to endorse or promote
//         products derived from this software without specific prior written
//         permission.
//  
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
//  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
//  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
//  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
//  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
//  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
//  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
//  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
//  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
//  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
//  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

#import <Foundation/Foundation.h>

//nsuserdefaults
#define kUserDefault_TomatoAgent_downloadOptions				@"ttagent_downloadOptions"	//the 'map' key of defaultDownloadOptions

//BitTorrent.*.defaults
#define kTomatoAgentModuleDefaultsKey_list						@"list"
#define kTomatoAgentModuleDefaultsKey_map						@"map"
#define kTomatoAgentModuleDefaultsKey_boolKeys					@"boolKeys"
#define kTomatoAgentModuleDefaultsEntryIndex_value				1
#define kTomatoAgentModuleDefaultsEntryIndex_description		2

//initial state info.
#define kTomatoAgentKey_downloadState_name					@"name"
#define kTomatoAgentKey_downloadState_size					@"size"
#define kTomatoAgentKey_downloadState_saveas				@"saveas"		//this is supplied by you.
#define kTomatoAgentKey_downloadState_isDirectory			@"isDirectory"	//safest is to check intValue != 0; could be string or int.

//rest of the keys that I know about
#define kTomatoAgentKey_downloadState_downtotal				@"downtotal"
#define kTomatoAgentKey_downloadState_uptotal				@"uptotal"
#define kTomatoAgentKey_downloadState_errors				@"errors"
#define kTomatoAgentKey_downloadState_fault					@"fault"		//these mean that it's hosed. Response 'fault' also set.
#define kTomatoAgentKey_downloadState_destPath				@"destPath"		//this can change on you once a download starts. Otherwise it's what

#define kTomatoAgentKey_downloadState_status				@"status"
#define kTomatoAgentKey_downloadState_status_activity		@"activity"	//seeding, check_hashes, shut down, initial startup, downloading, or error string.

#define kTomatoAgentKey_downloadState_status_activity_checkingFile	@"checking existing file"
#define kTomatoAgentKey_downloadState_status_activity_downloading	@"downloading"
#define kTomatoAgentKey_downloadState_status_activity_seeding		@"seeding"
#define kTomatoAgentKey_downloadState_status_activity_startup		@"Initial startup"
#define kTomatoAgentKey_downloadState_status_activity_shutDown		@"shut down"


#define kTomatoAgentKey_downloadState_status_downRate		@"downRate"
#define kTomatoAgentKey_downloadState_status_downTotal		@"downTotal"
#define kTomatoAgentKey_downloadState_status_fractionDone	@"fractionDone"
#define kTomatoAgentKey_downloadState_status_numCopies		@"numCopies"
#define kTomatoAgentKey_downloadState_status_numCopyList	@"numCopyList"
#define kTomatoAgentKey_downloadState_status_numPeers		@"numPeers"
#define kTomatoAgentKey_downloadState_status_numSeeds		@"numSeeds"
#define kTomatoAgentKey_downloadState_status_timeEst		@"timeEst"
#define kTomatoAgentKey_downloadState_status_upRate			@"upRate"
#define kTomatoAgentKey_downloadState_status_upRate2		@"upRate2"
#define kTomatoAgentKey_downloadState_status_upTotal		@"upTotal"
#define kTomatoAgentKey_downloadState_status_hmsTimeEstimate	@"hmsTimeEstimate"
#define kTomatoAgentKey_downloadState_status_TomatoDownloadSizeBytes @"TomatoDownloadSizeBytes"

#define kTomatoAgentKey_downloadState_stats_storage_numComplete		@"storage_numcomplete"
#define kTomatoAgentKey_downloadState_stats_storage_dirty			@"storage_dirty"
#define kTomatoAgentKey_downloadState_stats_storage_numFlunked		@"storage_numflunked"
#define kTomatoAgentKey_downloadState_stats_storage_active			@"storage_active"

#define kTomatoAgentKey_downloadParameter_maxUploadRate		@"max_upload_rate"
#define kTomatoAgentKey_downloadParameter_maxOpenFiles		@"max_files_open"
#define kTomatoAgentKey_downloadParameter_changePortAction	@"change_port"

#define kTomatoAgentKey_tracker_dfile						@"dfile"
#define kTomatoAgentKey_tracker_port						@"port"
#define kTomatoAgentKey_tracker_allowedDir					@"allowed_dir"
#define kTomatoAgentKey_tracker_logfile						@"logfile"

#define kTomatoAgentKey_trackerState_status					@"status"
#define kTomatoAgentKey_trackerState_statusSetAtTime		@"statusSetAtTime"

#define kTomatoAgentKey_trackerState_status_running			@"running"
#define kTomatoAgentKey_trackerState_status_limbo			@"limbo"
#define kTomatoAgentKey_trackerState_status_none			@"None"			//status for asking about a tracker that doesn't exist.

#define kTomatoAgentKey_generate_files						@"_agent_files"			//dict, values are file paths.
#define kTomatoAgentKey_generate_filesAttribs				@"_agent_filesAttribs"	//dict, value is dict for each file
#define kTomatoAgentKey_generate_destDirPath				@"_agent_destDir"		//path
#define kTomatoAgentKey_generate_trackerURL					@"_agent_trackerURL"	//default tracker URL.
#define kTomatoAgentKey_generate_isTrackerless				@"_agent_trackerless"	//optional. set to "YES" if wanted.
#define kTomatoAgentKey_generate_DHTNodes					@"_agent_dht_nodes"		//optional. comma-separated list of host:port.
#define kTomatoAgentKey_generate_pieceSizePow2				@"piece_size_pow2"		//optional. default is in py-agent, currently 18.

#define kTomatoAgentKey_generate_fileAttrib_destDirPath		@"destDir"		//optional. default: kTomatoAgentKey_generate_destDir
#define kTomatoAgentKey_generate_fileAttrib_trackerURL		@"trackerURL"	//optional. default: kTomatoAgentKey_generate_trackerURL
#define kTomatoAgentKey_generate_fileAttrib_comment			@"comment"		//optional. default: nil

#define kTomatoAgentKey_generateState_status				@"status"
#define kTomatoAgentKey_generateState_statusSetAtTime		@"statusSetAtTime"

#define kTomatoAgentKey_generateState_status_limbo			@"limbo"		//unlikely to see this. starting always causes others to return
#define kTomatoAgentKey_generateState_status_finished		@"finished"		//eventually.
#define kTomatoAgentKey_generateState_status_running		@"running"
#define kTomatoAgentKey_generateState_status_failed			@"failed"		//will have fault in response

	//if you have one of these in the response you have them all.
#define kTomatoAgentKey_generateState_numFiles				@"numFiles"
#define kTomatoAgentKey_generateState_totalBytes			@"totalBytes"
#define kTomatoAgentKey_generateState_completedBytes		@"completedBytes"
#define kTomatoAgentKey_generateState_currentItemPath		@"currentItemPath"
#define kTomatoAgentKey_generateState_currentItemNum		@"currentItemNum"

#define kTomatoAgentKey_generateState_errors				@"errors"


#define kTomatoAgentKey_metainfo_sourceFile		@"source"
#define kTomatoAgentKey_metainfo_warnings		@"warnings"		//array
#define kTomatoAgentKey_metainfo_failure		@"failure"
#define kTomatoAgentKey_metainfo_arg			@"metainfo"

#define kTomatoAgentKey_metainfo_arg_origFiles		@"origFiles"
#define kTomatoAgentKey_metainfo_arg_filesFS		@"filesFs"
#define kTomatoAgentKey_metainfo_arg_name			@"name"
#define kTomatoAgentKey_metainfo_arg_nameFs			@"nameFs"
#define kTomatoAgentKey_metainfo_arg_pieceLength	@"pieceLength"
#define kTomatoAgentKey_metainfo_arg_announce		@"announce"
#define kTomatoAgentKey_metainfo_arg_hashes			@"hashes"
#define kTomatoAgentKey_metainfo_arg_infohash		@"infohash"
#define kTomatoAgentKey_metainfo_arg_isArchive		@"isArchive"
#define kTomatoAgentKey_metainfo_arg_sizes			@"sizes"
#define kTomatoAgentKey_metainfo_arg_totalBytes		@"totalBytes"
#define kTomatoAgentKey_metainfo_arg_comment		@"comment"
#define kTomatoAgentKey_metainfo_arg_creationDate	@"creation date"

#define kTomatoAgentKey_metainfo_arg_archiveContents		@"archiveContents"
#define kTomatoAgentKey_metainfo_arg_archiveContents_path	@"path"
#define kTomatoAgentKey_metainfo_arg_archiveContents_size	@"size"


#define kTomatoAgentKey_failure								@"failure"			//either all above keys or this key.
#define kTomatoAgentKey_failure_desc						@"desc"				//display to user
#define kTomatoAgentKey_failure_class						@"class"			//class of failure. has other keys

//strings table names
#define kTomatoAgentStringsTable_download					@"TomatoTorrentAgent"	//includes __stats
#define kTomatoAgentStringsTable_downloadState				kTomatoAgentStringsTable_download
#define kTomatoAgentStringsTable_tracker					kTomatoAgentStringsTable_downloadState
#define kTomatoAgentStringsTable_generate					kTomatoAgentStringsTable_downloadState
#define kTomatoAgentStringsTable_metainfo					kTomatoAgentStringsTable_downloadState
#define kTomatoAgentStringsTable_moduleDefaults				@"TomatoTorrentDefaults"
#define kTomatoAgentStringsTable_responseFaults				kTomatoAgentStringsTable_downloadState

#define TTAgentBundle_()								[NSBundle bundleForClass:[TomatoTorrentAgent class]]
//#define TTAgentBundle_()								[NSBundle mainBundle]
#define TTAgentLocalizedString_(string, table)			SKLocalizedStringFromTableInBundle((string), (table), TTAgentBundle_(), (string))

//notifications. 
//	notification keys.
#define kTomatoAgentNotifKey_response				@"response"

struct ttagent_context;

@interface TomatoTorrentAgent : NSObject 
{
	//thread stuff
	id				__transactions;
	unsigned		__numEffectiveTransactions;
	id				__transactionsLock;
	id				__shutdownLock;
	
	struct ttagent_context	*__agent;
	
	id		__downloadConfiguration;

	//data to give the tracker task
	int		__trackerPort;
	id		__trackerAllowedDirPath;
	id		__trackerLogFilePath;
	id		__trackerDfile;

	double	__displayInterval;
	
	id		__trackerOptions;
	BOOL	__didStartTracker;
	
	id		__generateOptions;
	
	id		__agentLock;
	
	id		__mainThreadPort;
	id		__taskThreadPort;
	id		__postSelectorData;
	id		__agentData;
}

//init execs the agent process (eventually; it happens in a thread).
- init;
- shutdown;									//don't do anything else after shutdown other than sending release.
- (BOOL) isRunning;							//agent shuts down when it can't understand responses from the agent process.
											//also via shutdown.

- mutex;									//only one thread can send messages to an agent at a time.

//	-- configuration download options
- setDownloadConfigurationDictionary:options;
- downloadConfigurationDictionary;
+ defaultDownloadConfigurationDictionary;

+ (void) setTorrentCachesDirectory:(NSString*)dir;
+ (NSString*)torrentCachesDirectory;

- setStatsUpdateInterval:(double)interval;	//	only effective before starting a download, not during.
- (double)statsUpdateInterval;				//	the display_interval, which is hidden from downloadOptions.

//	-- configuring tracker options.
//
//		TrackerDocument handles the intelligence for using this;  you should
//		use that and not this directly. I should have done that for downlods too.
//
+ defaultTrackerOptions;
- defaultTrackerOptions;
- trackerOptions;					//if not set with setTrackerOptions, defaults to defaultTrackerOptions' map.
- setTrackerOptions:dictionary;		//used when initiing by TrackerDocument

- setTrackerPort:(int)port;
- setTrackerLogFilePath:path;
- setTrackerStateFilePath:path;
- setTrackerAllowedDirPath:path;

- (int)trackerPort;
- trackerLogFilePath;
- trackerStateFilePath;
- trackerAllowedDirPath;

//	-- configuring generate options.
//
//
- generateOptions;					//	unlike the others, this includes everything that the below methods set.
									//	initially empty.
- setGenerateAnnounceURL:string;	//	### must set
- setGenerateDestDirPath:string;	//	### must set
- setGenerateTrackerless:(BOOL)foo;
- setGenerateDHTNodesString:nodes;	// comma-separated host:port. I'm lazy. actually, at this point it's apathy. @"" for auto.
- setGeneratePieceSize:(int)size;
- setGenerateFiles:paths;			//	### duh
- setGenerateFiles:paths withAttributes:dictionaries;		//if used and args are arrays, attribs' count must equal paths' count.
															//otherwise their keys must match.
- generateAnnounceURL;
- generateDestDirPath;
- (int)generatePieceSize;
- generateFiles;
- (NSArray*) generateFilesAndAttributes;	//result contains two objects, files and attribute dictionaries.
											//each are NSNull if they aren't in generateOptions.

//-- message requests to agent process. 
//	
//		To get a response 'sender' should implement the corresponding delegate method
//		(defined below) or listen to notifications with the name of the request selector
//		with self as the notification object. 
//
//		Returns nil or self. nil means that the agent is too backlogged to handle
//		the request. There's a delegate method & notif for being notified of those failures.

// metainfo
- metainfoPath:path delegate:sender;	//returns metainfo dictionary
- metainfo:sender;						//returns metainfo dictionary

// downloading
- startDownloadingToPath:path delegate:sender;
- endDownload:sender;
- restartDownload:sender;	//assumes everything has been set up correctly; use startDownloadingToPath:delegate:
- downloadState:sender;								//requests coalesced
- downloadConfigurationForKey:key delegate:sender;	//requests coalesced
- configureDownloadKey:key withValue:value delegate:sender;

// tracking
- startTracker:sender;
- stopTracker:sender;
- trackerState:sender;
- (BOOL) didStartTracker;

// generate
- startGenerate:sender;
- stopGenerate:sender;
- generateState:sender;

- getInfoForMetaInfoFileAtPath:path delegate:sender;

- (int)requestQueueSize;		//max number that can be waiting.
- (int)requestQueueBacklog;		//number currently waiting. if == max, requests will be rejected 
								//('requests' are the above messages).
								//if negative, the agent has shutdown.
@end

//------------------------------------------------------------------------------
//		• TomatoTorrentAgentResponseDelegate
//------------------------------------------------------------------------------

@interface NSObject (TomatoTorrentAgentResponseDelegate)
	//these are sent to the sender of the requests if they respond.
	//responses are also broadcasted through the notification center with
	//the name of the request (name of selector that initiated it) and
	//the agent object. These are sent from the main thread via the run loop.

- tomatoTorrentAgent:agent metainfo:response;				//loaded a metainfo, or just returning a request for one.
- tomatoTorrentAgent:agent downloadStartup:response;		//startDownloadingToPath:delegate:
- tomatoTorrentAgent:agent downloadEnded:response;
- tomatoTorrentAgent:agent downloadStarted:response;		//restartDownload:
- tomatoTorrentAgent:agent downloadState:response;
- tomatoTorrentAgent:agent downloadConfiguration:response;
- tomatoTorrentAgent:agent configuredDownload:response;

- tomatoTorrentAgent:agent trackerStartup:response;
- tomatoTorrentAgent:agent trackerStopped:response;
- tomatoTorrentAgent:agent trackerState:response;			//useful to find out if it's running; status key in responseData.

- tomatoTorrentAgent:agent generateStartup:response;		//if status == running and any stat (like numFiles) is set,
- tomatoTorrentAgent:agent generateStopped:response;		// all stats are available.
- tomatoTorrentAgent:agent generateState:response;			//if status == failed, response fault is set.

- tomatoTorrentAgent:agent metainfo:response;

/* 	tomatoTorrentAgent:backloggedRequest:wasRejected:backlogCount

	requestName			The name of the selector that tried to queue a request.
	
	rejected			whether requestName was rejected (some requests are coalesced 
						so they are accepted even if backlogged).

	numRequestsWaiting	Number of effective requests in the queue (as opposed to actual
						number of items in the queue as a result of coalescing). 
						Useful to compare against [agent requestQueueSize].
	
	This is also sent to the notification center with /this/ selector name, not requestName.
*/
- tomatoTorrentAgent:agent backloggedRequest:requestName wasRejected:(BOOL)rejected backlogCount:(int)effectiveCount;	
@end

//------------------------------------------------------------------------------
//		• TomatoTorrentAgentResponse
//------------------------------------------------------------------------------

@interface TomatoTorrentAgentResponse : NSObject <NSCopying>
{
	id		__response;
	id		__name;
	double	__duration;
}
- responseContent;					//'data' key of the response. a plist object.
- fault;							//'fault' key
- request;							//name of selector on TomatoTorrentAgent that caused the response

- (double) conversationDuration;	//time it took to get a response, not including the time waiting in request queue.
- responseDictionary;				//entire response dictionary. useful for debugging.
@end
